#include<bits/stdc++.h>
using namespace std;
long long h=1,n,i,j,a[200000];
ifstream f1("BAI1_16.inp");
ofstream f2("BAI1_16.out");
void luu(int n,int i)
{
	if(n>1)
	{
		if(n%i==0)
		{
			luu(n/i,i);
			a[h]=i;
			h++;
		}	
		else 
		{
			i++;
			luu(n,i);
		}
	}
}
int main()
{
	int max=a[1];
	f1>>n;
	luu(n,2);
	for(i=1;i<=h-1;i++)
	if(a[i]>max) max=a[i];
	f2<<max;
}
